//RWStructuredBuffer<float3> RWValueBuffer : BACKBUFFER;
AppendStructuredBuffer<float3> AppendPositionBuffer : BACKBUFFER;
ByteAddressBuffer vData;
int buffersize;

StructuredBuffer<float2> UVPos <String uiname="UVPos";>;

float Epsilon = 1e-10;

bool UVSpace=0;
[numthreads(256,1,1)]
void CS(uint3 dtid : SV_DispatchThreadID)
{
//	if (dtid.x > buffersize) { return; }
	
	
	uint size, stride;
	UVPos.GetDimensions(size,stride);
	
	float2 uv = float2(asfloat(vData.Load(dtid.x * 32 + 24)),asfloat(vData.Load(dtid.x * 32 + 28)));
	float3 pos = float3(asfloat(vData.Load(dtid.x * 32)), asfloat(vData.Load(dtid.x * 32+4)), asfloat(vData.Load(dtid.x * 32+8)));
	
	
	float2 CorPos;
	
	for (uint i=0; i<= size; i++) {
		
	if(!UVSpace){
		
		
		CorPos=UVPos[i]*0.5*float2(1,-1)+0.5;
		
		}else
		
		{
			
			CorPos=UVPos[i];
			
		}
		
		
	
		
		if (CorPos.x > uv.x-Epsilon && CorPos.x < uv.x+Epsilon && CorPos.y > uv.y-Epsilon && CorPos.y < uv.y+Epsilon){
			
	AppendPositionBuffer.Append(float3(pos));
		}
		
	}
	
	//	RWValueBuffer[dtid.x] = pos;
	
}




technique11 UV
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}


